# $Id: calc.y,v 1.4 2005/11/20 13:29:32 aamine Exp $
#
# Very simple calculater.

class Calcp
  prechigh
    nonassoc UMINUS
    left '*' '/'
    left '+' '-'
  preclow
rule
  target: exp
        | /* none */ { result = 0 }

  exp: exp '+' exp
     {
       result.insert(result.begin_preorder, val[1])
       result.append_child_tree(result.begin_preorder, val[2])
       return result
     }
     | exp '-' exp
     {
       result.insert(result.begin_preorder, val[1])
       result.append_child_tree(result.begin_preorder, val[2])
       return result
     }
     | exp '*' exp
     {
       result.insert(result.begin_preorder, val[1])
       result.append_child_tree(result.begin_preorder, val[2])
       return result
     }
     | exp '/' exp
     {
       result.insert(result.begin_preorder, val[1])
       result.append_child_tree(result.begin_preorder, val[2])
       return result
     }
     | '(' exp ')' { result = val[1] }
     | '-' NUMBER  =UMINUS
     {
       result = Creek::Tree.new
       result.insert(result.begin_preorder, val[0])
       return result
     }
     | NUMBER
     {
       result = Creek::Tree.new
       result.insert(result.begin_preorder, val[0])
       return result
     }
end

---- header
# $Id: calc.y,v 1.4 2005/11/20 13:29:32 aamine Exp $
require 'creek_tree'
---- inner
  def parse(str)
    @q = []
    until str.empty?
      case str
      when /\A\s+/
      when /\A\d+/
        @q.push [:NUMBER, $&.to_i]
      when /\A.|\n/o
        s = $&
        @q.push [s, s]
      end
      str = $'
    end
    @q.push [false, '$end']
    do_parse
  end

  def next_token
    @q.shift
  end

---- footer

parser = Calcp.new
puts
puts 'type "Q" to quit.'
puts

num1 = 0
while true
  puts
  print '? '
  str = gets.chop!
  break if /q/i =~ str
  tree1 = nil
  begin
    tree1 = parser.parse(str)
  rescue ParseError
    puts $!
  end
  if(tree1 != nil)
    filename = "ast" + num1.to_s + ".dot"
    file1 = File.open(filename, 'w')
    file1.puts(tree1.output_dot)
    file1.close
    puts "file #{filename} was saved"
    num1 = num1 + 1
  end
end

