#------------------------------------------------------------
#    creek tree test01
#------------------------------------------------------------

require 'creek_tree'

#---- test_preorder
def test_preorder
  tree0 = Creek::Tree.new
  root = tree0.begin_preorder
  f = tree0.insert(root, "F")
  b = tree0.append_child(f, "B")
  g = tree0.append_child(f, "G")
  a = tree0.append_child(b, "A")
  d = tree0.append_child(b, "D")
  c = tree0.append_child(d, "C")
  e = tree0.append_child(d, "E")
  i = tree0.append_child(g, "I")
  h = tree0.append_child(i, "H")
  
  strtmp = String.new("preorder increment: ")
  ite1 = tree0.begin_preorder
  end1 = tree0.end_preorder
  while(ite1 != end1)
    strtmp << ite1.get_value.to_s
    ite1.get_next
  end
  puts strtmp
  
  strtmp = "preorder decrement: "
  ite1 = tree0.end_preorder
  end1 = tree0.begin_preorder
  while(ite1 != end1)
    ite1.get_prev
    strtmp << ite1.get_value.to_s
  end
  puts strtmp
  file1 = File.open("tree_test01.dot", 'w')
  file1.puts(tree0.output_dot)
  file1.close
end

#---- test_postorder
def test_postorder
  tree0 = Creek::Tree.new
  root = tree0.begin_preorder
  f = tree0.insert(root, "F")
  b = tree0.append_child(f, "B")
  g = tree0.append_child(f, "G")
  a = tree0.append_child(b, "A")
  d = tree0.append_child(b, "D")
  c = tree0.append_child(d, "C")
  e = tree0.append_child(d, "E")
  i = tree0.append_child(g, "I")
  h = tree0.append_child(i, "H")
  strtmp = String.new("postorder increment: ")
  ite1 = tree0.begin_postorder
  end1 = tree0.end_postorder
  while(ite1 != end1)
    strtmp << ite1.get_value.to_s
    ite1.get_next
  end
  puts strtmp
  
  strtmp = "postorder decrement: "
  end1 = tree0.begin_postorder
  while(ite1 != end1)
    ite1.get_prev
    strtmp << ite1.get_value.to_s
  end
  puts strtmp
end

#---- test_insert
def test_insert
  tree0 = Creek::Tree.new
  root = tree0.begin_preorder
  f = tree0.insert(root, "F")
  b = tree0.append_child(f, "B")
  g = tree0.append_child(f, "G")
  a = tree0.append_child(b, "A")
  d = tree0.append_child(b, "D")
  c = tree0.append_child(d, "C")
  e = tree0.append_child(d, "E")
  i = tree0.append_child(g, "I")
  h = tree0.append_child(i, "H")
  
  #insert at d
  tree0.insert(d, "J")
  b.node.insert_child(1, "K")
  b.node.prepend_child("L")
  b.node.prepend_child("M")
  
  strtmp = String.new("insert: ")
  ite1 = tree0.begin_postorder
  end1 = tree0.end_postorder
  while(ite1 != end1)
    strtmp << ite1.get_value.to_s
    ite1.get_next
  end
  puts strtmp
  
  strtmp = "insert: "
  end1 = tree0.begin_postorder
  while(ite1 != end1)
    ite1.get_prev
    strtmp << ite1.get_value.to_s
  end
  puts strtmp
end

def test_erase
  tree0 = Creek::Tree.new
  root = tree0.begin_preorder
  f = tree0.insert(root, "F")
  b = tree0.append_child(f, "B")
  g = tree0.append_child(f, "G")
  a = tree0.append_child(b, "A")
  d = tree0.append_child(b, "D")
  c = tree0.append_child(d, "C")
  e = tree0.append_child(d, "E")
  i = tree0.append_child(g, "I")
  h = tree0.append_child(i, "H")
  
  strtmp = String.new("erase at B: ")
  tree0.erase(b)
  ite1 = tree0.begin_preorder
  end1 = tree0.end_preorder
  while(ite1 != end1)
    strtmp << ite1.get_value.to_s
    ite1.get_next
  end
  puts strtmp
  
  strtmp = String.new("erase at root:")
  tree0.erase(tree0.begin_preorder)
  ite1 = tree0.begin_preorder
  end1 = tree0.end_preorder
  while(ite1 != end1)
    strtmp << ite1.get_value.to_s
    ite1.get_next
  end
  puts strtmp
end

test_preorder
test_postorder
test_insert
test_erase



